(* This file was originally generated by why.
   It can be modified; only the generated parts will be overwritten. *)

Require Why.

Parameter gcd : Z -> Z -> Z.

Axiom gcd_asubb_b : (a,b:Z) (gcd a b) = (gcd `a-b` b).
Axiom gcd_a_bsuba : (a,b:Z) (gcd a b) = (gcd a `b-a`).
Axiom gcd_a_a : (a:Z) (gcd a a) = a.
Axiom gcd_a_0 : (a:Z) (gcd a `0`) = a.
Axiom gcd_a_amodb : (a,b:Z) (gcd a b) = (gcd b (Zmod a b)).

Hints Resolve gcd_asubb_b gcd_a_bsuba gcd_a_a gcd_a_0 gcd_a_amodb.

Definition max : Z->Z->Z := 
  [x,y] Cases (Z_le_gt_dec x y) of (left _) => y | (right _) => x end.

(* Why obligation from file "gcd.mlw", characters 373-385 *)
Lemma gcd1_po_1 : 
  (a: Z)
  (b: Z)
  (Pre4: `a > 0` /\ `b > 0`)
  (x: Z)
  (Post5: x = a)
  (y: Z)
  (Post4: y = b)
  (Variant1: Z)
  (x1: Z)
  (y1: Z)
  (Pre3: Variant1 = (max x1 y1))
  (Pre2: `0 < x1` /\ `0 < y1` /\ `(gcd x1 y1) = (gcd a b)`)
  (Test4: `x1 <> y1`)
  (Test3: `x1 > y1`)
  (x2: Z)
  (Post1: x2 = `x1 - y1`)
  (`0 < x2` /\ `0 < y1` /\ `(gcd x2 y1) = (gcd a b)`) /\
  (Zwf `0` (max x2 y1) (max x1 y1)).
Proof.
Intuition.
Subst x2; Rewrite <- H4; Auto.
Unfold Zwf max.
Case (Z_le_gt_dec x2 y1); Case (Z_le_gt_dec x1 y1); Intros; Omega.
Save.

(* Why obligation from file "gcd.mlw", characters 401-413 *)
Lemma gcd1_po_2 : 
  (a: Z)
  (b: Z)
  (Pre4: `a > 0` /\ `b > 0`)
  (x: Z)
  (Post5: x = a)
  (y: Z)
  (Post4: y = b)
  (Variant1: Z)
  (x1: Z)
  (y1: Z)
  (Pre3: Variant1 = (max x1 y1))
  (Pre2: `0 < x1` /\ `0 < y1` /\ `(gcd x1 y1) = (gcd a b)`)
  (Test4: `x1 <> y1`)
  (Test2: `x1 <= y1`)
  (y2: Z)
  (Post2: y2 = `y1 - x1`)
  (`0 < x1` /\ `0 < y2` /\ `(gcd x1 y2) = (gcd a b)`) /\
  (Zwf `0` (max x1 y2) (max x1 y1)).
Proof.
Intuition.
Subst y2; Rewrite <- H4; Auto.
Unfold Zwf max.
Assert h:~x1=y1. Assumption. 
Case (Z_le_gt_dec x1 y2); Case (Z_le_gt_dec x1 y1); Intros; Omega.
Save.

(* Why obligation from file "gcd.mlw", characters 281-320 *)
Lemma gcd1_po_3 : 
  (a: Z)
  (b: Z)
  (Pre4: `a > 0` /\ `b > 0`)
  (x: Z)
  (Post5: x = a)
  (y: Z)
  (Post4: y = b)
  `0 < x` /\ `0 < y` /\ `(gcd x y) = (gcd a b)`.
Proof.
Intuition.
Subst; Reflexivity.
Save.

(* Why obligation from file "gcd.mlw", characters 430-432 *)
Lemma gcd1_po_4 : 
  (a: Z)
  (b: Z)
  (Pre4: `a > 0` /\ `b > 0`)
  (x: Z)
  (Post5: x = a)
  (y: Z)
  (Post4: y = b)
  (x1: Z)
  (y1: Z)
  (Post3: (`0 < x1` /\ `0 < y1` /\ `(gcd x1 y1) = (gcd a b)`) /\ `x1 = y1`)
  `x1 = (gcd a b)`.
Proof.
Intuition.
Rewrite <- H5; Rewrite H2.
Auto.
Save.


(* Why obligation from file "gcd.mlw", characters 705-712 *)
Lemma gcd2_po_1 : 
  (a: Z)
  (b: Z)
  (Pre5: `a >= 0` /\ `b >= 0`)
  (x: Z)
  (Post6: x = a)
  (y: Z)
  (Post5: y = b)
  (Variant1: Z)
  (x1: Z)
  (y1: Z)
  (Pre4: Variant1 = y1)
  (Pre3: `0 <= x1` /\ `0 <= y1` /\ `(gcd x1 y1) = (gcd a b)`)
  (Test2: `y1 <> 0`)
  ~(y1 = `0`).
Proof.
Intuition.
Save.

(* Why obligation from file "gcd.mlw", characters 723-759 *)
Lemma gcd2_po_2 : 
  (a: Z)
  (b: Z)
  (Pre5: `a >= 0` /\ `b >= 0`)
  (x: Z)
  (Post6: x = a)
  (y: Z)
  (Post5: y = b)
  (Variant1: Z)
  (x1: Z)
  (y1: Z)
  (Pre4: Variant1 = y1)
  (Pre3: `0 <= x1` /\ `0 <= y1` /\ `(gcd x1 y1) = (gcd a b)`)
  (Test2: `y1 <> 0`)
  (Pre2: ~(y1 = `0`))
  (r: Z)
  (Post3: r = (Zmod x1 y1))
  (x2: Z)
  (Post1: x2 = y1)
  (y2: Z)
  (Post2: y2 = r)
  (`0 <= x2` /\ `0 <= y2` /\ `(gcd x2 y2) = (gcd a b)`) /\ (Zwf `0` y2 y1).
Proof.
Intuition.
Assert h_y0 : ~ `y1 = 0`. Assumption.
Assert h1_y0 : `y1 > 0`. Omega.
Generalize (Z_mod_lt x1 y1 h1_y0); Intro.
Subst y2 r; Tauto.
Subst y2 x2 r.
Rewrite <- H4; Auto.
Unfold Zwf.
Assert h_y0 : ~ `y1 = 0`. Assumption.
Assert h1_y0 : `y1 > 0`. Omega.
Generalize (Z_mod_lt x1 y1 h1_y0); Omega.
Save.

(* Why obligation from file "gcd.mlw", characters 635-676 *)
Lemma gcd2_po_3 : 
  (a: Z)
  (b: Z)
  (Pre5: `a >= 0` /\ `b >= 0`)
  (x: Z)
  (Post6: x = a)
  (y: Z)
  (Post5: y = b)
  `0 <= x` /\ `0 <= y` /\ `(gcd x y) = (gcd a b)`.
Proof.
Intuition.
Subst; Reflexivity.
Save.

(* Why obligation from file "gcd.mlw", characters 776-778 *)
Lemma gcd2_po_4 : 
  (a: Z)
  (b: Z)
  (Pre5: `a >= 0` /\ `b >= 0`)
  (x: Z)
  (Post6: x = a)
  (y: Z)
  (Post5: y = b)
  (x1: Z)
  (y1: Z)
  (Post4: (`0 <= x1` /\ `0 <= y1` /\ `(gcd x1 y1) = (gcd a b)`) /\ `y1 = 0`)
  `x1 = (gcd a b)`.
Proof.
Intuition.
Rewrite <- H5; Rewrite H2; Auto.
Save.


